EDIT - task #6258

task # 6044 (Closed): cdm model changes/entensions for algea registry
Add Registration to cdm model

12/08/2016 09:59 AM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm Estimated time: 0:00 hour
Target version: CDM UML 4.7

Severity: critical

Description

For the Algea-Registry the model needs to be extended by a Registration class (for the detailed discussion see #6044)
The class Registration:

class Registration {

private String(255) identifier;

private String(255) specificIdentifier; //id without http-domain
private org.joda.time.DateTime registrationDate;

private Enum status;

private Institution institution;

private TaxonNameBase name;

private Set<TypeDesignationBase> typeDesignations;

private Set<Registration> blockedBy;

private User submitter;

The class will have n-1 relation to TaxonNameBase and an n-m associations to TypeDesignationBase:
TaxonNameBase [1]-—————————

-———[m] Registration

/

TypeDesignationBase [n]--—

RegistrationStatus
see cdm-vaadin:src/main/java/eu/etaxonomy/cdm/mock/RegistrationStatus.java

public enum RegistrationStatus {

preparation,// A new record which is being edited by the Author
curation, //A record ready for the curator to be validated.

ready, //The record has passed the validation by the curator and is ready for publication.

published, //The name or typification has finally been published.
rejected

//The registration has been rejected, the process is aborted and the record is preserved.

}

Related issues:
Related to PhycoBank - task #6168: Full registration workflow model Closed
Related to PhycoBank - task #6513: RegistrationWorkingSet to be modeled expli... Rejected
Related to EDIT - bug #6842: NPE in Registration constructor when name is null Closed
Precedes (7 days) EDIT - task #6612: Implement dao and service class for Regi... Closed

Associated revisions

Revision 09c24be2 - 04/06/2017 02:37 PM - Andreas Miiller

ref #6258 first imcomplete version of Registration class

Revision 2ac4df70 - 04/06/2017 02:37 PM - Andreas Miiller
ref #6258 add Registration to hibernate mapping and make in Annotatable and add update script

Revision d4aa7{24 - 04/30/2017 09:42 AM - Andreas Miiller
ref #6258 add Audited to Registration

Revision b10eca3b - 04/30/2017 09:44 AM - Andreas Miiller
ref #6258 , ref #6529 adapt test dll for Registration and WorkingSet

Revision b66167fa - 05/03/2017 12:05 AM - Andreas Miiller
ref #6529, ref #6258 improve MN TableCreator and missing ForeignKey handling (add index instead)

Revision cf43¢570 - 05/04/2017 10:47 PM - Andreas Kohlbecker

ref #6258 satisfying @NonNull annotations for collection properties

Revision 4c8dfa57 - 05/05/2017 12:04 AM - Andreas Miiller
ref #6258 add RegistrationStatus to EnumUserType

Revision a82850a1 - 05/05/2017 06:19 PM - Andreas Miiller
ref #6258 Added basic bidirectionality for Registration.name and typeDesignation

Revision e43aa1df - 05/06/2017 10:35 AM - Andreas Miiller

ref #6258 fix update script and tests for bidirectional type-registration

Revision 126e4675 - 06/05/2017 06:35 PM - Andreas Miiller
ref #6258, #6535, #3734 some updates to CdmUpdater after checking against H2

Revision c98bc251 - 11/21/2017 12:36 PM - Andreas Miiller

ref #6258 add cascading for registration in TaxonName and TypeDesignationBase

Revision 6fac03ea - 05/11/2018 11:53 AM - Andreas Miiller
ref #6258 add Registration.blockedBy Adder and Remover

History

#1 - 12/08/2016 10:04 AM - Andreas Kohlbecker

- Project changed from PhycoBank to EDIT

- Category set to cdm

- Target version set to Release 4.5

- Severity set to critical

For the Algea-Registry the model needs to be extended by a Registration class (for the detailed discussion see #6044)
The class Registration:

class Registration {

private String(255) identifier;

private String(255) specificIdentifier; //id without http-domain
private org.joda.time.DateTime registrationDate;
private Enum status;
private Institution institution;
private TaxonNameBase name;
private Set<TypeDesignationBase> typeDesignations;
}
The class will have n-1 relation to TaxonNameBase and an n-m associations to TypeDesignationBase:
TaxonNameBase [l1]-——————-
———-[m] Registration

/

TypeDesignationBase [n]--—

#2 - 12/08/2016 10:05 AM - Andreas Kohlbecker

- Assignee set to Andreas Miiller

#3 - 12/08/2016 11:04 AM - Andreas Miiller
- Target version changed from Release 4.5 to COM UML 4.7

#4 - 12/08/2016 11:07 AM - Andreas Miiller
- Related to task #6168: Full registration workflow model added

#5 - 12/08/2016 11:08 AM - Andreas Miiller

We also need a new Enum RegistrationStatus, with instances defined in #6168

#6 - 12/08/2016 01:14 PM - Andreas Miiller
- Status changed from New to In Progress

- Priority changed from New to Highest

#7 - 03/07/2017 02:45 PM - Andreas Kohlbecker

- Description updated

A registration in progress can be dependant on another registration which needs to be completed before it is possible to advance.
Therefore the Registration class should be extended to be able to reflect this dependency. | suggest adding a Collection field:

private Set<Registration> dependsOn;

#8 - 03/07/2017 06:05 PM - Andreas Kohlbecker

We need to be able to associate Registrations with Users and CRUD of Registrations need to be controlled via GrantedAuthorities. Therefore the
Registration needs to be sub class of CdmBase.

#9 - 03/08/2017 02:21 PM - Andreas Miiller
- Description updated
Andreas Kohlbecker wrote:

A registration in progress can be dependant on another registration which needs to be completed before it is possible to advance.
Therefore the Registration class should be extended to be able to reflect this dependency. | suggest adding a Collection field:

private Set<Registration> dependsOn;

We decided to call it blockedBy, not dependsOn

#10 - 03/10/2017 12:56 PM - Andreas Kohlbecker

Andreas Kohlbecker wrote:

We need to be able to associate Registrations with Users and CRUD of Registrations need to be controlled via GrantedAuthorities. Therefore the

04/10/2024 3/9


https://dev.e-taxonomy.eu/redmine/issues/6168

Registration needs to be sub class of CdmBase.

In a follow up discussion on the above considerations we concluded that the Registration should have an association to User, so that the person
being responsible for the registration is clearly related to the registration. Naming suggestions for this property:

editor
author
originator
initiator

#11 - 03/10/2017 12:57 PM - Andreas Kohlbecker
- Description updated

#12 - 03/10/2017 01:16 PM - Andreas Miiller

Andreas Kohlbecker wrote:
Andreas Kohlbecker wrote:

We need to be able to associate Registrations with Users and CRUD of Registrations need to be controlled via GrantedAuthorities.
Therefore the Registration needs to be sub class of CdmBase.

In a follow up discussion on the above considerations we concluded that the Registration should have an association to User, so that the person
being responsible for the registration is clearly related to the registration. Naming suggestions for this property:

editor
author
originator
initiator

Can you please define semantics of the new attribute a bit more. Is the person the one who "applied" for the new name or is it the person who works
on the registration process (in this case usually WHK). The translations | found for originator http:/dict.leo.org/englisch-deutsch/originator do not
make this clear (it is both "Antragsteller" and "Bearbeiter"). Therefore this term might not be the best.

#13 - 03/10/2017 03:12 PM - Andreas Kohlbecker
Andreas Miller wrote:
Can you please define semantics of the new attribute a bit more. Is the person the one who "applied" for the new name or is it the person who

works on the registration process (in this case usually WHK). The translations | found for originator http:/dict.leo.org/englisch-deutsch/originator
do not make this clear (it is both "Antragsteller" and "Bearbeiter"). Therefore this term might not be the best.

This is the person who initiated the registration process. This is either the author (or one of a team) of the according publication or someone who is
doing a post publication registration on behalf of the actual author. | would not use the verb "apply" in this context. | think talking of submissions is
more appropriate, since this is also what is happening at the publishers side. The author submits the publication of a new name and it submits in the
same sense the data for registration. WHK is only the person doing the data curation. Data curation is a manual validation of the data entered of the
submitter . A data curator is not working on the registration process.

Maybe submitter is better than originator.

#14 - 03/10/2017 03:19 PM - Andreas Miiller

- Description updated

Andreas Kohlbecker wrote:

Andreas Muller wrote:

Maybe submitter is better than originator.

Yes | agree, if WHK also agrees we can fix this. Already changed the label in the above description.

#15 - 03/13/2017 10:24 AM - Andreas Kohlbecker
[Henning wrote]

Hallo Andreas,

ich habe grundsatzlich immer Schwierigkeiten mit solchen Substantiven.
Erst nach Leo-Befragung, kann ich mich dem ,originator” halbwegs anschlieBen, nach LEO passt das sogar besser. In bezug auf diese ganzen
Substantive des Englischen habe ich tiberhaupt kein Spachgefiihl. [Provider wiirde hier wegen des Gebrauchs in der GBIF-Welt nicht passen]

Echte Frage: Warum denn nicht einfach ,ProvidedBy" oder ,SubmittedBy*“ ? [originated by wiirde schon wieder schlechter passen]

Viele Grufe,
Henning

#16 - 03/13/2017 10:25 AM - Andreas Kohlbecker
Also submittedBy?
Alle einverstanden?

#17 - 03/13/2017 10:28 AM - Wolf-Henning Kusber

ist mein Favorit, Henning

#18 - 03/13/2017 10:26 PM - Andreas Miiller

it is a bit against our CDM conventions. At other places we say collector and not collected by, or combinationAuthor not xxxBy, etc. The only by that
we use is createdBy and updatedBy for the first and the last user who worked on a record.

But if you prefer submittedBy | can live with it.

#19 - 03/13/2017 10:46 PM - Andreas Miiller

Can you please add the Enum states required for the status?
Is it ok to call the enum class RegistrationStatus?

#20 - 03/13/2017 11:01 PM - Andreas Miiller

Should submitted(By) really be of type "User", not of type Person, Team or Agent? Is it always necessary that a submitter has access rights?
Currently a User can only be Person, so this prevents teams or institutions to become submitters.

#21 - 03/13/2017 11:24 PM - Andreas Miiller
Can you please add information about bidirectionality.
So, should a name link to it's registrations (probably yes)
Should a submitter link to it's registrations (probably no),
For all bidirectional relationships please add the name and type of the attribute at the other side (e.g
Set<Registration> registrations
in TaxonNameBase
#22 - 03/13/2017 11:26 PM - Andreas Miiller
Andreas Miller wrote:
Can you please add the Enum states required for the status?

Is it ok to call the enum class RegistrationStatus?

What should be the default state? Or is NULL allowed and the default?

#23 - 03/14/2017 08:31 AM - Andreas Kohlbecker

A Registration without a state makes not much sense. A new Registration should have the state preparation.
The states are listed in #6168

#24 - 03/14/2017 08:32 AM - Andreas Kohlbecker
Andreas Kohlbecker wrote:
A Registration without a state makes not much sense. A new Registration should have the state preparation.

preparation will therefore the default State.
The states are listed in #6168
#25 - 03/14/2017 08:45 AM - Andreas Kohlbecker

- Description updated

Andreas Miller wrote:
Can you please add the Enum states required for the status?
Is it ok to call the enum class RegistrationStatus?

The enum states are now added to the issue description. The enum already exists in the source code, see cdm-vaadin:
src/main/java/eu/etaxonomy/cdm/mock/RegistrationStatus.java

#26 - 03/14/2017 08:50 AM - Andreas Kohlbecker
Andreas Muller wrote:

it is a bit against our CDM conventions. At other places we say collector and not collected by, or combinationAuthor not xxxBy, etc. The only by
that we use is createdBy and updatedBy for the first and the last user who worked on a record.

But if you prefer submittedBy | can live with it.

The votes for this decision are:

e AM: +1 for submitter
e AK: +1 for submitter
e WHK: +1 for submittedBy

So it is 2:1 for submitter. Consistency in the model naming convention is important, for the Ul we always can change the 'submitter' into 'submittedBy".
Therefore let's name it submitter

#27 - 03/14/2017 12:12 PM - Andreas Kohlbecker
Andreas Muller wrote:
Can you please add information about bidirectionality.
So, should a name link to it's registrations (probably yes)
Should a submitter link to it's registrations (probably no),
For all bidirectional relationships please add the name and type of the attribute at the other side (e.g
Set<Registration> registrations
in TaxonNameBase
e name: should link to its Registration
¢ submitter: | think that we don't need a back reference here
¢ typeDesignation: since the name links to its Registration the typeDesignation also should
Does everybody agree?
#28 - 03/14/2017 12:13 PM - Andreas Kohlbecker
Andreas Muller wrote:
Should submitted(By) really be of type "User", not of type Person, Team or Agent? Is it always necessary that a submitter has access rights?
Currently a User can only be Person, so this prevents teams or institutions to become submitters.
Ich denke, dass Agent die besser Wahl wére. Damit waren wir am flexibelsten. Andererseits wiirde dadurch aber auch das "Einsammeln” der
Registrierungen fiir einen Nutzer aufwandiger da zwei Falle beriicksichtigt werden missen:

User->Person->Registration
User->Person->Team->Registration

Andreas

#29 - 03/16/2017 03:56 PM - Andreas Miiller
- Related to task #6513: RegistrationWorkingSet to be modeled explicitely? added

04/10/2024 6/9



#30 - 03/16/2017 03:59 PM - Andreas Kohlbecker

Ja, das ware ein bisschen aufwendiger. Aber sicherlich I6sbar. Ein bisschen schwieriger ist der Fall bei Institutionen. Da ist der Zusammenhang zum
User ja noch unschérfer.
Aber auch das ware ldsbar denke ich.

Grundsatzlich stellt sich aber vor allem die Frage, welches die Hauptgriinde sind, warum wir Gberhaupt einen Submitter brauchen.
Geht es v.a. darum anzuzeigen, wenn ich eingeloggt bin, wie es meinen Registrierungen geht oder geht es darum, der AuBenwelt etwas tUber den
Submitter der Registrierung was zu erzahlen. Wenn nur ersteres, wéare ,User" richtig, wenn auch Zweiteres wichtig, dann halte ich Agent fir sinniger.

AM

#31 - 03/16/2017 04:00 PM - Andreas Kohlbecker

Rein inhaltlich:

1. Ist es wichtig zu unterscheiden, zwischen Registrierungen von neuen Namen und alten Basionymen, die mitregistriert werden.
2. Ist es ein Qualitatskriterium, wenn Autoren der Namen auch Submitter des Eintrags sind.
3. Spéter ist dann auch wichtig, ob es sich um einen menschlichen Eintrag oder eine ,Maschinenregistrierung” handelt

#32 - 03/16/2017 04:00 PM - Andreas Kohlbecker

Aus technischer und organisatorischer Sicht ist der Submitter vor allem wichtig um die Registrierungen die zu einem User gehdren herausfiltern zu
kénnen.

Die Berechtigungen sind in dieser Situation irrelevant. Es geht hierbei nur um die Zuordnung. Der Submitter wird in den meisten Fallen auch immer
der Creator sein, es sei denn eine Registrierung wird auf einen anderen User lbertragen, weil einer der Autoren eines Teams die Durchfiihrung der
Registrierung an jemand andren abgibt.

Die Basis einer jeden Registrierung ist immer eine Publikation, also entweder die nomenklatorische Referenz des neuen Namens oder die 'citation'
der TypeDesignation. Falls eine Registrierung mehrere TypeDesignations umfasst missen alle die selbe citation und citationMicroreference haben.
Uber diese 'Referenzen' besteht schon eine Relation zu dem Autor/AutorenTeam. Bei post-publication Registrierungen aber wird der Submitter/User
in vielen Fallen nicht dem Autorenteam angehéren. Wir brauchen also auf jeden Fall eine separate Relation zu der Person, welche die Registrierung
aktuell bearbeitet. Hier stellt sich die Frage ob das nicht auch mehrere Personen sein kénnen? Sollten wir den Fall beriicksichtigen, dass es ein Team
also mehrere Personen geben kann, die gemeinsam die Registrierung bearbeiten? Bei Massenpublikationen von vielen Namen in ein und der selben
Publikation ist es durchaus vorstellbar, dass das Team sich die Arbeit teilen mdchte. In diesem Fall gabe es mehrere User.

Es gibt in CDM-Java gesprochen also folgende Mdglichkeiten:

A) Set<User> submitters;

oder

B) User submitter;

oder

C) Agent submitter;

Mit scheint (A) mittlerweile am sinnvollsten zu sein.

Andreas

#33 - 03/16/2017 05:47 PM - Andreas Kohlbecker

Nach abschlieBender Diskussion mit Henning ist klar geworden, dass der Fall mehrerer User eigentlich irrelevant ist. Wir kbnnen davon ausgehen
dass es immer nur ein User sein wird der sich um die Registrierung aller Namen und Typen in einer Publikation kimmert. Sollte der Fall auftreten,
dass ein Team gemeinsam die Registrierungen bearbeiten will muss sich das Team einen Useraccount anlegen dessen Credentials dem gesamten
Team bekannt gemacht werden so dass alle zugriff haben. Ubrigens wollen

Publisher auch immer mit genau einer Person, dem Corresponding Author kommunizieren.

Also: "The winner is ...."

User submitter;

Ta da da daaaaaaal!!!!

#34 - 04/05/2017 12:17 AM - Andreas Muller

What class should Registration inherit from? CdmBase, VersionableEntity, AnnotatableEntity, IdentifiableEntity?

#35 - 04/05/2017 12:17 AM - Andreas Miiller
- Priority changed from New to Highest

#36 - 04/05/2017 03:43 PM - Andreas Kohlbecker
Andreas Muller wrote:

What class should Registration inherit from? CdmBase, VersionableEntity, AnnotatableEntity, IdentifiableEntity?

AnnotatableEntity is the right one!

#37 - 04/28/2017 11:52 AM - Andreas Kohlbecker

After the discussion this week | am thinking about renaming the Registration class to NomenclaturalAct, this term would be less application purpose
oriented an the more correct term from the process in the scientific process.

#38 - 04/28/2017 03:21 PM - Andreas Miiller

I think NomenclaturalAct is a broader term then Registration. It is also valid for existing NomenclaturalActs in published publications which are
obviously not covered by the current class while many attributes of the class are not usefull for existing Nomenclatural acts (specificldentifier,
Identifier, Institution, maybe even status).

#39 - 04/29/2017 12:59 AM - Andreas Miiller
- Status changed from In Progress to Resolved

- Assignee changed from Andreas Miller to Andreas Kohlbecker

#40 - 05/02/2017 03:47 PM - Andreas Kohlbecker
- Tags set to phycobank

#41 - 05/02/2017 03:52 PM - Andreas Kohlbecker

- Precedes task #6612: Implement dao and service class for Registrations added

#42 - 05/04/2017 10:45 PM - Andreas Kohlbecker
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Kohlbecker to Andreas Miller

when accessing persisted Registration | get this error:

java.lang.IllegalArgumentException: EnumType RegistrationStatus not supported by EnumUserType.
at eu.etaxonomy.cdm.hibernate.EnumUserType.nullSafeGet (EnumUserType.java:109)
at eu.etaxonomy.cdm.hibernate.EnumUserType.nullSafeGet (EnumUserType.java:l)
at org.hibernate.type.CustomIype.nullSafeGet (CustomType.java:110)
at org.hibernate.type.AbstractType.hydrate (AbstractType. java:85)
at org.hibernate.persister.entity.AbstractEntityPersister.hydrate (AbstractEntityPersister.java:2727)
at org.hibernate.loader.Loader.loadFromResultSet (Loader. java:1728)
at org.hibernate.loader.Loader.instanceNotYetLoaded (Loader. java:1654)
at org.hibernate.loader.Loader.getRow (Loader.java:1543)
at org.hibernate.loader.Loader.getRowFromResultSet (Loader.java:727)
at org.hibernate.loader.Loader.processResultSet (Loader. java:972)
at org.hibernate.loader.Loader.doQuery (Loader.java:930)
at org.hibernate.loader.Loader.doQueryAndInitializeNonLazyCollections (Loader.java:336)
at org.hibernate.loader.Loader.doList (Loader.java:2611)
at org.hibernate.loader.Loader.doList (Loader. java:2594)
at org.hibernate.loader.Loader.listIgnoreQueryCache (Loader.java:2423)
at org.hibernate.loader.Loader.list (Loader.java:2418)
at org.hibernate.loader.criteria.Criterialoader.list (CriteriaLoader.java:109)
at org.hibernate.internal.SessionImpl.list (SessionImpl.java:1774)
at org.hibernate.internal.CriteriaImpl.list (CriteriaImpl. java:363)
at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.list (CdmEntityDaoBase. java:836)
at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.list (VersionableDaoBase. java:184)
at eu.etaxonomy.cdm.api.service.ServiceBase.list (ServiceBase.java:161)

this happens at:

TransactionStatus tx = repo.startTransaction (true);
List<Registration> allRegs = repo.getRegistrationService().list (null, null, null, null, null);

#43 - 05/05/2017 12:05 AM - Andreas Muller

Andreas Kohlbecker wrote:

when accessing persisted Registration | get this error:
should be fixed with 4c8dfa574

#44 - 05/05/2017 12:06 AM - Andreas Miiller
- Status changed from Feedback to Resolved

- Assignee changed from Andreas Muiller to Andreas Kohlbecker

#45 - 05/05/2017 12:23 AM - Andreas Miuller

Andreas Muller wrote:
Andreas Kohlbecker wrote:

when accessing persisted Registration | get this error:

should be fixed with 4c8dfa574

But be careful, there are new model changes. Need to run update script from scratch.

#46 - 06/20/2017 06:55 PM - Andreas Miiller

can this be closed?

#47 - 06/20/2017 09:22 PM - Andreas Kohlbecker

- Status changed from Resolved to Closed

#48 - 07/21/2017 03:35 PM - Andreas Kohlbecker

- Related to bug #6842: NPE in Registration constructor when name is null added
